var f:text;
const M=8; (* numero di segmenti per ciclo *)
      N=2; (* numero di cicli *)
      M2=M*2;
      side2=true; (* 2-side *)

procedure writelight(x,y,z:real;r,g,b:real);
begin
writeln(f,'directionalLight{');
writeln(f,'        direction ',x,' ',y,' ',z);
writeln(f,'        color ',r,' ',g,' ',b);
writeln(f,'        }');
end;

procedure buildclass;
var i:integer;
begin
writeln(f,'IndexedFaceSet{ CoordIndex[');
if side2
then begin
     for i:=0 to N*M-1
     do begin
          write(f,'   ',2*i,' ',2*i+3,' ',2*i+1,' ,');
          writeln(f,'   ',2*i,' ',2*i+2,' ',2*i+3,' ,');
         end;
     i:=N*M;
     write(f,'   ',2*i,' ',2*i+3,' ',2*i+1,' ,');
     writeln(f,'   ',2*i,' ',2*i+2,' ',2*i+3,',');
     end;

for i:=0 to N*M-1
do begin
     write(f,'   ',2*i,' ',2*i+1,' ',2*i+3,' ,');
     writeln(f,'   ',2*i,' ',2*i+3,' ',2*i+2,' ,');
    end;
i:=N*M;
write(f,'   ',2*i,' ',2*i+1,' ',2*i+3,' ,');
writeln(f,'   ',2*i,' ',2*i+3,' ',2*i+2,']}}');
end;

procedure writevertex;
var i:integer;
begin
writeln(f,'typedef mElica structure');
write(f,'{coordinate3 { point[');
for i:=0 to N*M+1
do begin
   writeln(f,'  ',cos(i/M*2*Pi),' ',sin(i/M*2*Pi),' ',i/M,',');
   write(f,'  ',2*cos(i/M*2*Pi),' ',2*sin(i/M*2*Pi),' ',i/M);
   if i=N*M+1
   then writeln(f,']}')
   else writeln(f,',');
   end;
buildclass;
end;

begin
assign(f,'ELICA.DAT');
{$I-}
rewrite(f);
{$I+}
if IOResult <> 0
then begin
     writeln('Cannot open output file');
     halt;
     end;
writeln(f,'''Created by ELICA.PAS');
writeln(f,'''3DL rev 0.4');
writelight(-1,0,1,1,1,0);
writelight(-1,0,-1,1,0,1);
writevertex;
writeln(f,'structure { transform { translation[6 0 0] } mElica}');
close(f);
end.