const N=8;M=4; (* M > 2 !! *)
var f:text;

procedure buildclass;
var i,J:integer;
begin
write(f,'IndexedFaceSet { coordIndex[');
for j:=0 to M-2
do for i:=0 to N-1
   do writeln(f,'          ',i+j*N,' ',(i+1)mod N+j*N,' ',(i+1)mod N+j*N+N,' ',i+j*N+N,',');
for i:=0 to N-1
do begin
   write(f,'          ',i+(M-1)*N,' ',(i+1)mod N+(M-1)*N,' ',M*N);
   if i = N-1
   then writeln(f,']}')
   else writeln(f,',')
   end
end;

procedure writevertex;
var i,j:integer;
    cs,sn:real;
begin
writeln(f,'directionalLight { direction 1 0 0 color 1 1 0 }');
writeln(f,'typedef mfunction structure {');
writeln(f,'coordinate3 { point[');
for j:=0 to M-1
do begin
   cs:=cos(j/(M+1)*Pi*0.5);
   sn:=sin(j/(M+1)*Pi*0.5);
   for i:=0 to N-1
   do writeln(f,'  ',cs*cos(i/N*2*Pi),' ',cs*sin(i/N*2*Pi),' ',sn,',');
   end;
writeln(f,'  0 0 1]}');
buildclass;
writeln(f,'}');
end;

begin
assign(f,'NEW.DAT');
{$I-}
rewrite(f);
{$I+}
if IOResult <> 0
then begin
     writeln('Cannot open output file');
     halt;
     end;
writeln(f,'''Created by NEWDAT.PAS');
writeln(f,'''3DL rev 0.4');
writevertex;
writeln(f,'structure { transform { translation[6 0 0] } mfunction }');
close(f);
end.