program test1_3d; (* 3D 0.4 *)
uses drivers,crt,graph3d,data3d,file3d;
{ this program requires TEST1.DAT }
{$B-}  { BOOLEAN SHORT CIRCUIT }

const phistep=0.1;  { step della direzione dell'osservatore  }
      kbShift=kbLeftShift + kbRightShift;
      n_step=20;

var change,exit:boolean;
    a:pnode;
    linstep:real;
    fault:boolean;
    i,count:integer;cmode:tmode;
    tid:tident;
    xo,yo,zo:real; { posizione dell' osservatore }
    phi:real; { direzione di visione in radianti }
    obj:array[1..4]of record
              posizione:tpoint;
              p:pnode;
           end;
    delta:real;

procedure svuota_buffer;
begin
inline($FA); { disable interrupts }
MemW[0:$41A]:=MemW[0:$41C];
inline($FB); { enable interrupts }
end; { of svuota_buffer }

begin
fault:=false;
cmode:=color256;
for i:=1 to ParamCount
do if ParamStr(i) = '/16'
   then cmode:=color16
   else if ParamStr(i) = '/256'
        then cmode:=color256
        else if (ParamStr(i) = '/BW') or (ParamStr(i) = '/bw')
             then cmode:=gray64
             else fault:=true;
if fault
then begin
     writeln('Usage: test1 [/16 | /256 | /BW]');
     halt(1);
     end;
a:=nil;readfile(a,'test1');
opengraph(cmode);
obj[1].p:=ident.table[ident.search('sfera1',tid)].entityp;
obj[2].p:=ident.table[ident.search('sfera2',tid)].entityp;
obj[3].p:=ident.table[ident.search('sfera3',tid)].entityp;
obj[4].p:=ident.table[ident.search('sfera4',tid)].entityp;
for i:=1 to 4
do if obj[i].p = nil
   then halt(1);
with obj[1].posizione
do begin x:=8;y:=2;z:=2;end;
with obj[2].posizione
do begin x:=8;y:=-2;z:=2;end;
with obj[3].posizione
do begin x:=12;y:=2;z:=2;end;
with obj[4].posizione
do begin x:=12;y:=-2;z:=2;end;
delta:=4/n_step;
phi:=0;
xo:=1.2;
yo:=0;
zo:=1.1;
change:=true;
exit:=false;linstep:=0;
count:=0;
repeat
if (linstep=0)and not change
then repeat until keypressed
else show(a,xo,yo,zo,phi,1.57);
inc(count);
if count = n_step
then begin
     count:=0;
     end;
for i:=1 to 4
do begin
   with obj[i].posizione
   do begin
      z:=2+8*count/n_step*(1-count/n_step);
      if x >= 12
      then y:=y + delta
      else if x <= 8
           then y:=y - delta;
      if y <= -2
      then begin
           y:=-2;
           x:=x+delta;
           end;
      if y >= 2
      then begin
           y:=2;
           x:=x-delta;
           end
      end;
   with obj[i]
   do set_position(p,posizione);
   end;
if keypressed
then case readkey of
     #0:begin
        change:=true;
        case readkey of
        'H':begin
            if GetShiftState and kbShift <> 0
            then zo:=zo+0.2                      (* shift+up arrow *)
            else linstep:=linstep+0.03;          (* up arrow       *)
	    end;
        'P':begin
            if GetShiftState and kbShift <> 0
            then zo:=zo-0.2                      (* shift+up arrow *)
            else linstep:=linstep-0.03;          (* up arrow       *)
	    end;
        'K':phi:=(phi+phistep); {left arrow}
        'M':phi:=(phi-phistep); {right arrow}
          else change:=false;
          end;
        end;
  #27:begin
	exit:=true;
	end;
end;{of case}
linstep:=0.95*linstep;
if abs(linstep)<0.01
then linstep:=0;
xo:=xo+linstep*cos(phi);
yo:=yo+linstep*sin(phi);
svuota_buffer; { impedisce che il buffer di tastiera si possa riempire }
until exit;
closegraph;
end.
