program test2_3d;
uses drivers,crt,graph3d,data3d,file3d;
{ this program requires TEST2.DAT }
{$B-}  { BOOLEAN SHORT CIRCUIT }

const phistep=0.1;  { step della direzione dell'osservatore  }
      kbShift=kbLeftShift + kbRightShift;

var change,exit:boolean;
    a,p1,bulletp:pnode;life2:integer;
    linstep:real;
    fault:boolean;
    i:integer;cmode:tmode;
    tid:tident;
    oss,toss,temp:tpoint;
    phi:real; { direzione di visione in radianti }

procedure svuota_buffer;
begin
inline($FA); { disable interrupts }
MemW[0:$41A]:=MemW[0:$41C];
inline($FB); { enable interrupts }
end; { of svuota_buffer }

begin
fault:=false;
cmode:=color256;
for i:=1 to ParamCount
do if ParamStr(i) = '/16'
   then cmode:=color16
   else if ParamStr(i) = '/256'
        then cmode:=color256
        else if (ParamStr(i) = '/BW') or (ParamStr(i) = '/bw')
             then cmode:=gray64
             else fault:=true;
if fault
then begin
     writeln('Usage: test2 [/16 | /256 | /BW]');
     halt(1);
     end;
a:=nil;readfile(a,'test2');
opengraph(cmode);
bulletp:=ident.table[ident.search('small',tid)].entityp;
if bulletp=nil
then halt(1);
bulletp^.attivo:=false;life2:=0;
phi:=0;
oss.x:=6;
oss.y:=1;
oss.z:=0;
change:=true;
exit:=false;linstep:=0;
repeat
if (linstep=0)and not change
then repeat until keypressed
else show(a,oss.x,oss.y,oss.z,phi,1.57);
if bulletp^.attivo
then begin
     move_position(bulletp,0.2);
     p1:=DetectCollision(bulletp,a);
     if (p1 <> nil)
     then begin
          p1^.attivo:=false;
          bulletp^.attivo:=false;
          life2:=0;
          end
     else begin
          dec(life2);
          if life2 = 0
          then bulletp^.attivo:=false;
          end;
     end;
toss:=oss;
if keypressed
then case readkey of
     #0:begin
        change:=true;
        case readkey of
        'H':begin
            if GetShiftState and kbShift <> 0
            then oss.z:=oss.z+0.2                      (* shift+up arrow *)
            else linstep:=linstep+0.03;          (* up arrow       *)
	    end;
        'P':begin
            if GetShiftState and kbShift <> 0
            then oss.z:=oss.z-0.2                      (* shift+up arrow *)
            else linstep:=linstep-0.03;          (* up arrow       *)
	    end;
        'K':phi:=(phi+phistep); {left arrow}
        'M':phi:=(phi-phistep); {right arrow}
          else change:=false;
          end;
        end;
  ' ':begin
        bulletp^.attivo:=true;
        set_rotation2(bulletp,cos(phi),sin(phi));
        temp:=oss;
        temp.z:=temp.z-0.5;
        Set_Position(bulletp,temp);
        life2:=100;
      end;
  #27:begin
	exit:=true;
	end;
end;{of case}
linstep:=0.95*linstep;
if abs(linstep)<0.01
then linstep:=0;
oss.x:=oss.x+linstep*cos(phi);
oss.y:=oss.y+linstep*sin(phi);
if PointIsIncluded(oss,a,phi) <> nil
then begin
       oss:=toss;
       linstep:=0;
     end;
svuota_buffer; { impedisce che il buffer di tastiera si possa riempire }
until exit;
closegraph;
end.
